# dana jest lista ułamków opisanych jako pary [licznik, mianownik]
# wypisz uporządkowane rosnąco ułamki

ulamki = [[5, 9], [7, 100], [1, 2], [5, 51], [2, 3], [5, 11]]

def klucz(u):
    return u[0] / u[1]

def sort_ulam1(ulamki):
    ulamki.sort(key = klucz)

def NWD(a, b):
    while b!= 0:
        a, b = b, a % b
    return a

def NWW(a, b):
    return (a // NWD(a, b)) * b

def sort_ulam2(ulamki):
    mian = NWW(ulamki[0][1], ulamki[1][1])
    n = len(ulamki)
    for i in range(2, n):
        mian = NWW(mian, ulamki[i][1])
    #sprowadzam do wspólnego mianownika
    for i in range(n):
        ulamki[i][0] = ulamki[i][0] * (mian // ulamki[i][1])
        ulamki[i][1] = mian
    ulamki.sort()
    #skracamy ulamki
    for i in range(n):
        pom = NWD(ulamki[i][0], ulamki[i][1])
        ulamki[i][0] = ulamki[i][0] // pom
        ulamki[i][1] = ulamki[i][1] // pom


print(ulamki)
sort_ulam2(ulamki)
print(ulamki)
